using System;
using Ilungasoft.Helper.Data;

namespace Ilungasoft.Helper.TestApp.DomainObject
{
    public class About : Entity<About>, IEntity
    {
        public About() : base()
        {
        }

        public int ID
        {
            get { return (int)keyValues[0]; }
            set { keyValues[0] = value; }
        }

        public string Title
        {
            get { return (string)keyValues[1]; }
            set { keyValues[1] = value; }
        }

        public string Content
        {
            get { return (string)keyValues[2]; }
            set { keyValues[2] = value; }
        }

        public bool Deletable
        {
            get { return (bool)keyValues[3]; }
            set { keyValues[3] = value; }
        }

        public int Order
        {
            get { return (int)keyValues[4]; }
            set { keyValues[4] = value; }
        }

        public void SetPropertyValue(string key, object val)
        {
                if (key.Equals("ID"))
                {
                    keyValues[0] = val;
                }
                else if (key.Equals("Title"))
                {
                    keyValues[1] = val;
                }
                else if (key.Equals("Content"))
                {
                    keyValues[2] = val;
                }
                else if (key.Equals("Deletable"))
                {
                    keyValues[3] = val;
                }
                else if (key.Equals("Order"))
                {
                    keyValues[4] = val;
                }
            }

        public new string[] GetMemberNames(params string[] exceptMembers)
        {
            return Entity<About>.GetMemberNames(exceptMembers);
        }

        public new object[] GetMemberValues(params string[] exceptMembers)
        {
            return base.GetMemberValues(exceptMembers);
        }
    }
}
