using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using Ilungasoft.Helper.Data;

namespace Ilungasoft.Helper.TestApp.DomainObject
{
    class About2
    {
        public About2()
        {
        }

        public int ID
        {
            get { return (int)keyValues["ID"]; }
            set { keyValues["ID"] = value; }
        }

        public string Title
        {
            get { return (string)keyValues["Title"]; }
            set { keyValues["Title"] = value; }
        }

        public string Content
        {
            get { return (string)keyValues["Content"]; }
            set { keyValues["Content"] = value; }
        }

        public bool Deletable
        {
            get { return (bool)keyValues["Deletable"]; }
            set { keyValues["Deletable"] = value; }
        }

        public int Order
        {
            get { return (int)keyValues["Order"]; }
            set { keyValues["Order"] = value; }
        }

        public void SetPropertyValue(string key, object val)
        {
            keyValues[key] = val;
        }

        public new string[] GetMemberNames(params string[] exceptMembers)
        {
            return Entity<About>.GetMemberNames(exceptMembers);
        }

        public new object[] GetMemberValues(params string[] exceptMembers)
        {
            return base.GetMemberValues(exceptMembers);
        }

    }
}
